/*
 File:       puntatori3.c
 Specifica:  esempi sui puntatori a array
 Versioni:   25/2/2002 == versione iniziale
*/

// include header standard
#include <stdio.h>

/*    un array di tipo X equivale ad un puntatore (costante) 
      al tipo X  che punta al primo elemento dell'array
*/

int main()
{
  /* A vettore di interi */
  int A[] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9}; 
  
  /* p e q puntatori ad interi */
  int * p, * q; 

  p =  A; /* p  punta all'inizio del vettore A 
	    equivalente a  p = &A[0] */

  printf("*p = %d\n", *p ); /* stampo A[0] */

  printf("*A = %d\n", *A ); /* stampo A[0] */

  printf("*(p+5) = %d\n", *(p+5) ); /* stampo A[5] */

  printf("p[5] = %d\n", p[5] ); /* uso p come un array */

  q = &A[3]; /* ora q punta a A[3] */

  p++; /* ora p punta ad A[1] */

  printf("q[5] = %d\n", q[5] ); /* stampo A[8]! */

  printf("q - p = %d\n", q - p ); /* differenza tra puntatori */

  if( q > p ) /* confronto tra puntatori */
    printf("q e' maggiore di p!\n");


  /* decommentando il seguente comando si ha un errore di compilazione:
     non e' possibile modificare A!

     A++; 
  */
  return 0;
}

